<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::Input&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1Input.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1Input-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::Input&lt; T &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;  
 <a href="classOpenSim_1_1Input.html#details">More...</a></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for OpenSim::Input&lt; T &gt;:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classOpenSim_1_1Input.png" usemap="#OpenSim::Input_3C_20T_20_3E_map" alt=""/>
  <map id="OpenSim::Input_3C_20T_20_3E_map" name="OpenSim::Input_3C_20T_20_3E_map">
<area href="classOpenSim_1_1AbstractInput.html" title="A specialized Socket that connects to an Output signal is an Input." alt="OpenSim::AbstractInput" shape="rect" coords="0,56,154,80"/>
<area href="classOpenSim_1_1AbstractSocket.html" title="A Socket formalizes the dependency between a Component and another object (typically another Componen..." alt="OpenSim::AbstractSocket" shape="rect" coords="0,0,154,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a60818c34161d77ea849d7f8e1e3cb2ee"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1Input.html">Input</a>&lt; T &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#a60818c34161d77ea849d7f8e1e3cb2ee">clone</a> () const override</td></tr>
<tr class="memdesc:a60818c34161d77ea849d7f8e1e3cb2ee"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a dynamically-allocated copy.  <a href="classOpenSim_1_1Input.html#a60818c34161d77ea849d7f8e1e3cb2ee">More...</a><br /></td></tr>
<tr class="separator:a60818c34161d77ea849d7f8e1e3cb2ee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a958819e04ea16dfdd2f21aded9fc1620"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#a958819e04ea16dfdd2f21aded9fc1620">connect</a> (const <a class="el" href="classOpenSim_1_1AbstractOutput.html">AbstractOutput</a> &amp;output, const std::string &amp;alias=&quot;&quot;) override</td></tr>
<tr class="memdesc:a958819e04ea16dfdd2f21aded9fc1620"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> to the provided (Abstract)<a class="el" href="classOpenSim_1_1Output.html">Output</a>.  <a href="classOpenSim_1_1Input.html#a958819e04ea16dfdd2f21aded9fc1620">More...</a><br /></td></tr>
<tr class="separator:a958819e04ea16dfdd2f21aded9fc1620"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac76e261f646e7874b8c6d3cee808f9f3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#ac76e261f646e7874b8c6d3cee808f9f3">connect</a> (const <a class="el" href="classOpenSim_1_1AbstractChannel.html">AbstractChannel</a> &amp;channel, const std::string &amp;alias=&quot;&quot;) override</td></tr>
<tr class="memdesc:ac76e261f646e7874b8c6d3cee808f9f3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> to a single output channel.  <a href="classOpenSim_1_1Input.html#ac76e261f646e7874b8c6d3cee808f9f3">More...</a><br /></td></tr>
<tr class="separator:ac76e261f646e7874b8c6d3cee808f9f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac624dfe7f6745cc540e24f5702c48788"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#ac624dfe7f6745cc540e24f5702c48788">finalizeConnection</a> (const <a class="el" href="classOpenSim_1_1Component.html">Component</a> &amp;root) override</td></tr>
<tr class="memdesc:ac624dfe7f6745cc540e24f5702c48788"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> given a root <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> to search for the <a class="el" href="classOpenSim_1_1Output.html">Output</a> according to the connectee path of this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> <br  />
  <a href="classOpenSim_1_1Input.html#ac624dfe7f6745cc540e24f5702c48788">More...</a><br /></td></tr>
<tr class="separator:ac624dfe7f6745cc540e24f5702c48788"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0a27daeceeacbee82b8aff020eeb2394"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#a0a27daeceeacbee82b8aff020eeb2394">disconnect</a> () override</td></tr>
<tr class="memdesc:a0a27daeceeacbee82b8aff020eeb2394"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clear references to connectees.  <a href="classOpenSim_1_1Input.html#a0a27daeceeacbee82b8aff020eeb2394">More...</a><br /></td></tr>
<tr class="separator:a0a27daeceeacbee82b8aff020eeb2394"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad27bfffd1ac259beec88da553bc48dfd"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#ad27bfffd1ac259beec88da553bc48dfd">isConnected</a> () const override</td></tr>
<tr class="memdesc:ad27bfffd1ac259beec88da553bc48dfd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Derived classes must satisfy this Interface.  <a href="classOpenSim_1_1Input.html#ad27bfffd1ac259beec88da553bc48dfd">More...</a><br /></td></tr>
<tr class="separator:ad27bfffd1ac259beec88da553bc48dfd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d7ea27fe1bb3e2b065352a43232fe43"><td class="memItemLeft" align="right" valign="top">const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#a5d7ea27fe1bb3e2b065352a43232fe43">getValue</a> (const SimTK::State &amp;state) const</td></tr>
<tr class="memdesc:a5d7ea27fe1bb3e2b065352a43232fe43"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the value of this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> when it is connected.  <a href="classOpenSim_1_1Input.html#a5d7ea27fe1bb3e2b065352a43232fe43">More...</a><br /></td></tr>
<tr class="separator:a5d7ea27fe1bb3e2b065352a43232fe43"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a86aa8d43b3fe1d141f4755e4797296a9"><td class="memItemLeft" align="right" valign="top">const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#a86aa8d43b3fe1d141f4755e4797296a9">getValue</a> (const SimTK::State &amp;state, unsigned index) const</td></tr>
<tr class="memdesc:a86aa8d43b3fe1d141f4755e4797296a9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the value of this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> when it is connected.  <a href="classOpenSim_1_1Input.html#a86aa8d43b3fe1d141f4755e4797296a9">More...</a><br /></td></tr>
<tr class="separator:a86aa8d43b3fe1d141f4755e4797296a9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adf0a9ea71a9995320a834816d68386b3"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classOpenSim_1_1Input.html#a12f106eb91fe98191178beb550b6e1d9">Channel</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#adf0a9ea71a9995320a834816d68386b3">getChannel</a> () const</td></tr>
<tr class="memdesc:adf0a9ea71a9995320a834816d68386b3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the Channel associated with this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>.  <a href="classOpenSim_1_1Input.html#adf0a9ea71a9995320a834816d68386b3">More...</a><br /></td></tr>
<tr class="separator:adf0a9ea71a9995320a834816d68386b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4c06af7101d8955413ab1133880c0318"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classOpenSim_1_1Input.html#a12f106eb91fe98191178beb550b6e1d9">Channel</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#a4c06af7101d8955413ab1133880c0318">getChannel</a> (unsigned index) const</td></tr>
<tr class="memdesc:a4c06af7101d8955413ab1133880c0318"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the Channel associated with this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>.  <a href="classOpenSim_1_1Input.html#a4c06af7101d8955413ab1133880c0318">More...</a><br /></td></tr>
<tr class="separator:a4c06af7101d8955413ab1133880c0318"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a15519bc6a26bed98722bea0161173745"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#a15519bc6a26bed98722bea0161173745">getAlias</a> () const override</td></tr>
<tr class="memdesc:a15519bc6a26bed98722bea0161173745"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the alias for a Channel.  <a href="classOpenSim_1_1Input.html#a15519bc6a26bed98722bea0161173745">More...</a><br /></td></tr>
<tr class="separator:a15519bc6a26bed98722bea0161173745"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab3840d2041f8502ede51f07aa6ec6896"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#ab3840d2041f8502ede51f07aa6ec6896">getAlias</a> (unsigned index) const override</td></tr>
<tr class="memdesc:ab3840d2041f8502ede51f07aa6ec6896"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the alias for the Channel indicated by the provided index.  <a href="classOpenSim_1_1Input.html#ab3840d2041f8502ede51f07aa6ec6896">More...</a><br /></td></tr>
<tr class="separator:ab3840d2041f8502ede51f07aa6ec6896"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a52daca458b43b17ee594231fce365f1b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#a52daca458b43b17ee594231fce365f1b">setAlias</a> (const std::string &amp;alias) override</td></tr>
<tr class="memdesc:a52daca458b43b17ee594231fce365f1b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the alias for a Channel.  <a href="classOpenSim_1_1Input.html#a52daca458b43b17ee594231fce365f1b">More...</a><br /></td></tr>
<tr class="separator:a52daca458b43b17ee594231fce365f1b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1cda1dcc80abf531b0217f6d3316ed80"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#a1cda1dcc80abf531b0217f6d3316ed80">setAlias</a> (unsigned index, const std::string &amp;alias) override</td></tr>
<tr class="memdesc:a1cda1dcc80abf531b0217f6d3316ed80"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the alias for the Channel indicated by the provided index.  <a href="classOpenSim_1_1Input.html#a1cda1dcc80abf531b0217f6d3316ed80">More...</a><br /></td></tr>
<tr class="separator:a1cda1dcc80abf531b0217f6d3316ed80"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa5b6a623cc874ead09c9ff439af95627"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#aa5b6a623cc874ead09c9ff439af95627">getLabel</a> () const override</td></tr>
<tr class="memdesc:aa5b6a623cc874ead09c9ff439af95627"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the label for this Channel.  <a href="classOpenSim_1_1Input.html#aa5b6a623cc874ead09c9ff439af95627">More...</a><br /></td></tr>
<tr class="separator:aa5b6a623cc874ead09c9ff439af95627"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a870abe650f0cc83ff13fedbb60122696"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#a870abe650f0cc83ff13fedbb60122696">getLabel</a> (unsigned index) const override</td></tr>
<tr class="memdesc:a870abe650f0cc83ff13fedbb60122696"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the label for the Channel indicated by the provided index.  <a href="classOpenSim_1_1Input.html#a870abe650f0cc83ff13fedbb60122696">More...</a><br /></td></tr>
<tr class="separator:a870abe650f0cc83ff13fedbb60122696"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a48d5af73d4239b941e4c05a41cd3d290"><td class="memItemLeft" align="right" valign="top">SimTK::Vector_&lt; T &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#a48d5af73d4239b941e4c05a41cd3d290">getVector</a> (const SimTK::State &amp;state) const</td></tr>
<tr class="memdesc:a48d5af73d4239b941e4c05a41cd3d290"><td class="mdescLeft">&#160;</td><td class="mdescRight">Access the values of all the channels connected to this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> as a SimTK::Vector_&lt;T&gt;.  <a href="classOpenSim_1_1Input.html#a48d5af73d4239b941e4c05a41cd3d290">More...</a><br /></td></tr>
<tr class="separator:a48d5af73d4239b941e4c05a41cd3d290"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b68c470e1e79597d5e1a9b79d2927d0"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classOpenSim_1_1Input.html#aaa6a4e34de1c0547076a9b2a8b4c9789">ChannelList</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#a9b68c470e1e79597d5e1a9b79d2927d0">getChannels</a> () const</td></tr>
<tr class="memdesc:a9b68c470e1e79597d5e1a9b79d2927d0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get const access to the channels connected to this input.  <a href="classOpenSim_1_1Input.html#a9b68c470e1e79597d5e1a9b79d2927d0">More...</a><br /></td></tr>
<tr class="separator:a9b68c470e1e79597d5e1a9b79d2927d0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acc94ce44fe708b4b775307052428d252"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#acc94ce44fe708b4b775307052428d252">getConnecteeTypeName</a> () const override</td></tr>
<tr class="memdesc:acc94ce44fe708b4b775307052428d252"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the typename of the <a class="el" href="classOpenSim_1_1Output.html">Output</a> value, T, that satisfies this Input&lt;T&gt;.  <a href="classOpenSim_1_1Input.html#acc94ce44fe708b4b775307052428d252">More...</a><br /></td></tr>
<tr class="separator:acc94ce44fe708b4b775307052428d252"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad9899d15ec4d1f57db9736358819aca1"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#ad9899d15ec4d1f57db9736358819aca1">SimTK_DOWNCAST</a> (<a class="el" href="classOpenSim_1_1Input.html">Input</a>, <a class="el" href="classOpenSim_1_1AbstractInput.html">AbstractInput</a>)</td></tr>
<tr class="separator:ad9899d15ec4d1f57db9736358819aca1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classOpenSim_1_1AbstractInput"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classOpenSim_1_1AbstractInput')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classOpenSim_1_1AbstractInput.html">OpenSim::AbstractInput</a></td></tr>
<tr class="memitem:aa5c9e6000a9e9f55c94e359e797bca33 inherit pub_methods_classOpenSim_1_1AbstractInput"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#aa5c9e6000a9e9f55c94e359e797bca33">~AbstractInput</a> ()</td></tr>
<tr class="separator:aa5c9e6000a9e9f55c94e359e797bca33 inherit pub_methods_classOpenSim_1_1AbstractInput"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a10ae90fa015c07916d0986efe5e77144 inherit pub_methods_classOpenSim_1_1AbstractInput"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#a10ae90fa015c07916d0986efe5e77144">connect</a> (const <a class="el" href="classOpenSim_1_1Object.html">Object</a> &amp;object) override</td></tr>
<tr class="memdesc:a10ae90fa015c07916d0986efe5e77144 inherit pub_methods_classOpenSim_1_1AbstractInput"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect this Socket to the provided connectee object.  <a href="classOpenSim_1_1AbstractInput.html#a10ae90fa015c07916d0986efe5e77144">More...</a><br /></td></tr>
<tr class="separator:a10ae90fa015c07916d0986efe5e77144 inherit pub_methods_classOpenSim_1_1AbstractInput"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classOpenSim_1_1AbstractSocket"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classOpenSim_1_1AbstractSocket')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classOpenSim_1_1AbstractSocket.html">OpenSim::AbstractSocket</a></td></tr>
<tr class="memitem:a868b675e08eb429427ec1d0d95338ed8 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a868b675e08eb429427ec1d0d95338ed8">~AbstractSocket</a> ()</td></tr>
<tr class="separator:a868b675e08eb429427ec1d0d95338ed8 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5222469e0ef65d0dad0d7d0788a6c177 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a5222469e0ef65d0dad0d7d0788a6c177">getName</a> () const</td></tr>
<tr class="separator:a5222469e0ef65d0dad0d7d0788a6c177 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a881ce4fb9bf97d3b715100c8ce3b80b2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">SimTK::Stage&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a881ce4fb9bf97d3b715100c8ce3b80b2">getConnectAtStage</a> () const</td></tr>
<tr class="memdesc:a881ce4fb9bf97d3b715100c8ce3b80b2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the system Stage when the connection should be made.  <a href="classOpenSim_1_1AbstractSocket.html#a881ce4fb9bf97d3b715100c8ce3b80b2">More...</a><br /></td></tr>
<tr class="separator:a881ce4fb9bf97d3b715100c8ce3b80b2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0dec27d1742c1e67753e673023299b03 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a0dec27d1742c1e67753e673023299b03">isListSocket</a> () const</td></tr>
<tr class="memdesc:a0dec27d1742c1e67753e673023299b03 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Can this <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> have more than one connectee?  <a href="classOpenSim_1_1AbstractSocket.html#a0dec27d1742c1e67753e673023299b03">More...</a><br /></td></tr>
<tr class="separator:a0dec27d1742c1e67753e673023299b03 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4fc29c560fa59cbb29da0cdf4cf01ffe inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a4fc29c560fa59cbb29da0cdf4cf01ffe">getNumConnectees</a> () const</td></tr>
<tr class="memdesc:a4fc29c560fa59cbb29da0cdf4cf01ffe inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">The number of slots to fill in order to satisfy this socket.  <a href="classOpenSim_1_1AbstractSocket.html#a4fc29c560fa59cbb29da0cdf4cf01ffe">More...</a><br /></td></tr>
<tr class="separator:a4fc29c560fa59cbb29da0cdf4cf01ffe inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab7f51d3c1a841f4e3f00b38fee88c75e inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="classOpenSim_1_1Object.html">Object</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#ab7f51d3c1a841f4e3f00b38fee88c75e">getConnecteeAsObject</a> () const</td></tr>
<tr class="memdesc:ab7f51d3c1a841f4e3f00b38fee88c75e inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Generic access to the connectee.  <a href="classOpenSim_1_1AbstractSocket.html#ab7f51d3c1a841f4e3f00b38fee88c75e">More...</a><br /></td></tr>
<tr class="separator:ab7f51d3c1a841f4e3f00b38fee88c75e inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae783a456133f011142508e0fb9a0711c inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#ae783a456133f011142508e0fb9a0711c">findAndConnect</a> (const <a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> &amp;connectee)</td></tr>
<tr class="memdesc:ae783a456133f011142508e0fb9a0711c inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Find the connectee using a search with a partial path.  <a href="classOpenSim_1_1AbstractSocket.html#ae783a456133f011142508e0fb9a0711c">More...</a><br /></td></tr>
<tr class="separator:ae783a456133f011142508e0fb9a0711c inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2dccd9cd45ca0b08a4c13177dc5410bb inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a2dccd9cd45ca0b08a4c13177dc5410bb">findAndConnect</a> (const std::string &amp;connectee)</td></tr>
<tr class="memdesc:a2dccd9cd45ca0b08a4c13177dc5410bb inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Same as <a class="el" href="classOpenSim_1_1AbstractSocket.html#ae783a456133f011142508e0fb9a0711c" title="Find the connectee using a search with a partial path.">findAndConnect(const ComponentPath&amp;)</a>, but using a string argument.  <a href="classOpenSim_1_1AbstractSocket.html#a2dccd9cd45ca0b08a4c13177dc5410bb">More...</a><br /></td></tr>
<tr class="separator:a2dccd9cd45ca0b08a4c13177dc5410bb inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af76f658a08e1f323665eee8e90d1a7a9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#af76f658a08e1f323665eee8e90d1a7a9">setConnecteePath</a> (const std::string &amp;name)</td></tr>
<tr class="memdesc:af76f658a08e1f323665eee8e90d1a7a9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set connectee path.  <a href="classOpenSim_1_1AbstractSocket.html#af76f658a08e1f323665eee8e90d1a7a9">More...</a><br /></td></tr>
<tr class="separator:af76f658a08e1f323665eee8e90d1a7a9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7dd2d3233598f23465b4d6afbf19bd7a inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a7dd2d3233598f23465b4d6afbf19bd7a">setConnecteePath</a> (const std::string &amp;name, unsigned ix)</td></tr>
<tr class="memdesc:a7dd2d3233598f23465b4d6afbf19bd7a inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set connectee path of a connectee among a list of connectees.  <a href="classOpenSim_1_1AbstractSocket.html#a7dd2d3233598f23465b4d6afbf19bd7a">More...</a><br /></td></tr>
<tr class="separator:a7dd2d3233598f23465b4d6afbf19bd7a inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaf113a0c1e31f3b28dc732928d684a06 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#aaf113a0c1e31f3b28dc732928d684a06">getConnecteePath</a> () const</td></tr>
<tr class="memdesc:aaf113a0c1e31f3b28dc732928d684a06 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get connectee path.  <a href="classOpenSim_1_1AbstractSocket.html#aaf113a0c1e31f3b28dc732928d684a06">More...</a><br /></td></tr>
<tr class="separator:aaf113a0c1e31f3b28dc732928d684a06 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8cdf1ea4b8795edf8a8d1e0106707538 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a8cdf1ea4b8795edf8a8d1e0106707538">getConnecteePath</a> (unsigned ix) const</td></tr>
<tr class="memdesc:a8cdf1ea4b8795edf8a8d1e0106707538 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get connectee path of a connectee among a list of connectees.  <a href="classOpenSim_1_1AbstractSocket.html#a8cdf1ea4b8795edf8a8d1e0106707538">More...</a><br /></td></tr>
<tr class="separator:a8cdf1ea4b8795edf8a8d1e0106707538 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd80d0f355163910daea30d26a394430 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#afd80d0f355163910daea30d26a394430">appendConnecteePath</a> (const std::string &amp;name)</td></tr>
<tr class="separator:afd80d0f355163910daea30d26a394430 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac86784a65efd79dc1aad7f759b2b8cd9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#ac86784a65efd79dc1aad7f759b2b8cd9">clearConnecteePath</a> ()</td></tr>
<tr class="memdesc:ac86784a65efd79dc1aad7f759b2b8cd9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clear all connectee paths in the connectee path property.  <a href="classOpenSim_1_1AbstractSocket.html#ac86784a65efd79dc1aad7f759b2b8cd9">More...</a><br /></td></tr>
<tr class="separator:ac86784a65efd79dc1aad7f759b2b8cd9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8e98fd9f05712a934982f1ffba94ffe2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classOpenSim_1_1Component.html">Component</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a8e98fd9f05712a934982f1ffba94ffe2">getOwner</a> () const</td></tr>
<tr class="memdesc:a8e98fd9f05712a934982f1ffba94ffe2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get owner component of this socket.  <a href="classOpenSim_1_1AbstractSocket.html#a8e98fd9f05712a934982f1ffba94ffe2">More...</a><br /></td></tr>
<tr class="separator:a8e98fd9f05712a934982f1ffba94ffe2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ad5b573d163af29dc4029acb12432e0a6"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOpenSim_1_1Input.html">Input</a>&lt; T &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Input.html#ad5b573d163af29dc4029acb12432e0a6">safeDownCast</a> (<a class="el" href="classOpenSim_1_1AbstractInput.html">AbstractInput</a> *base)</td></tr>
<tr class="memdesc:ad5b573d163af29dc4029acb12432e0a6"><td class="mdescLeft">&#160;</td><td class="mdescRight">For use in python/java/MATLAB bindings.  <a href="classOpenSim_1_1Input.html#ad5b573d163af29dc4029acb12432e0a6">More...</a><br /></td></tr>
<tr class="separator:ad5b573d163af29dc4029acb12432e0a6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_static_methods_classOpenSim_1_1AbstractInput"><td colspan="2" onclick="javascript:toggleInherit('pub_static_methods_classOpenSim_1_1AbstractInput')"><img src="closed.png" alt="-"/>&#160;Static Public Member Functions inherited from <a class="el" href="classOpenSim_1_1AbstractInput.html">OpenSim::AbstractInput</a></td></tr>
<tr class="memitem:a2062b6259d1871de344a63341f19f53d inherit pub_static_methods_classOpenSim_1_1AbstractInput"><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#a2062b6259d1871de344a63341f19f53d">parseConnecteePath</a> (const std::string &amp;connecteePath, std::string &amp;componentPath, std::string &amp;outputName, std::string &amp;channelName, std::string &amp;alias)</td></tr>
<tr class="memdesc:a2062b6259d1871de344a63341f19f53d inherit pub_static_methods_classOpenSim_1_1AbstractInput"><td class="mdescLeft">&#160;</td><td class="mdescRight">Break up a connectee path into its output path, channel name (empty for single-value outputs), and alias.  <a href="classOpenSim_1_1AbstractInput.html#a2062b6259d1871de344a63341f19f53d">More...</a><br /></td></tr>
<tr class="separator:a2062b6259d1871de344a63341f19f53d inherit pub_static_methods_classOpenSim_1_1AbstractInput"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad11e499265b50f69bcaa3af34b972ad9 inherit pub_static_methods_classOpenSim_1_1AbstractInput"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#ad11e499265b50f69bcaa3af34b972ad9">composeConnecteePath</a> (const std::string &amp;componentPath, const std::string &amp;outputName, const std::string &amp;channelName, const std::string &amp;alias)</td></tr>
<tr class="memdesc:ad11e499265b50f69bcaa3af34b972ad9 inherit pub_static_methods_classOpenSim_1_1AbstractInput"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compose the connectee path from its constituents.  <a href="classOpenSim_1_1AbstractInput.html#ad11e499265b50f69bcaa3af34b972ad9">More...</a><br /></td></tr>
<tr class="separator:ad11e499265b50f69bcaa3af34b972ad9 inherit pub_static_methods_classOpenSim_1_1AbstractInput"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><h3>template&lt;class T&gt;<br />
class OpenSim::Input&lt; T &gt;</h3>

<p>An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt; </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a4d1e8b8a76452dc4d938742f19676fe3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4d1e8b8a76452dc4d938742f19676fe3">&#9670;&nbsp;</a></span>Input()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::<a class="el" href="classOpenSim_1_1Input.html">Input</a> </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const PropertyIndex &amp;&#160;</td>
          <td class="paramname"><em>connecteePathIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::Stage &amp;&#160;</td>
          <td class="paramname"><em>connectAtStage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Component.html">Component</a> &amp;&#160;</td>
          <td class="paramname"><em>owner</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Create an Input&lt;T&gt; (<a class="el" href="classOpenSim_1_1Socket.html">Socket</a>) that can only connect to an Output&lt;T&gt; name and stage at which it should be connected. </p>
<p>Only <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> should ever construct an <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>name of the <a class="el" href="classOpenSim_1_1Output.html">Output</a> dependency. </td></tr>
    <tr><td class="paramname">connecteePathIndex</td><td>Index of the property in the containing <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> that holds this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>'s connectee path(s). </td></tr>
    <tr><td class="paramname">connectAtStage</td><td>Stage at which <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> should be connected. </td></tr>
    <tr><td class="paramname">owner</td><td>The component that contains this input. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="a32745d1653d5939a4ca0025c5e08d81a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a32745d1653d5939a4ca0025c5e08d81a">&#9670;&nbsp;</a></span>AliasList</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;std::string&gt; <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::<a class="el" href="classOpenSim_1_1Input.html#a32745d1653d5939a4ca0025c5e08d81a">AliasList</a></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a12f106eb91fe98191178beb550b6e1d9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a12f106eb91fe98191178beb550b6e1d9">&#9670;&nbsp;</a></span>Channel</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="classOpenSim_1_1Output.html">Output</a>&lt;T&gt;::<a class="el" href="classOpenSim_1_1Input.html#a12f106eb91fe98191178beb550b6e1d9">Channel</a> <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::<a class="el" href="classOpenSim_1_1Input.html#a12f106eb91fe98191178beb550b6e1d9">Channel</a></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="aaa6a4e34de1c0547076a9b2a8b4c9789"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaa6a4e34de1c0547076a9b2a8b4c9789">&#9670;&nbsp;</a></span>ChannelList</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;SimTK::ReferencePtr&lt;const <a class="el" href="classOpenSim_1_1Input.html#a12f106eb91fe98191178beb550b6e1d9">Channel</a>&gt; &gt; <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::<a class="el" href="classOpenSim_1_1Input.html#aaa6a4e34de1c0547076a9b2a8b4c9789">ChannelList</a></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a60818c34161d77ea849d7f8e1e3cb2ee"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a60818c34161d77ea849d7f8e1e3cb2ee">&#9670;&nbsp;</a></span>clone()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1Input.html">Input</a>&lt;T&gt;* <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::clone </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Create a dynamically-allocated copy. </p>
<p>You must manage the memory for the returned pointer. This function exists to facilitate the use of SimTK::ClonePtr&lt;AbstractSocket&gt;. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractInput.html#a1495e040f3e49a876a554dafd0f44e80">OpenSim::AbstractInput</a>.</p>

</div>
</div>
<a id="ac76e261f646e7874b8c6d3cee808f9f3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac76e261f646e7874b8c6d3cee808f9f3">&#9670;&nbsp;</a></span>connect() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::connect </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1AbstractChannel.html">AbstractChannel</a> &amp;&#160;</td>
          <td class="paramname"><em>channel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>alias</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Connect this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> to a single output channel. </p>
<p>This method can be used with both single-valued and list Inputs. You can optionally provide an alias that will be used by the <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> owning this Input to refer to the Channel. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractInput.html#ae5efc02a932f1418e6c5f275404258b1">OpenSim::AbstractInput</a>.</p>

</div>
</div>
<a id="a958819e04ea16dfdd2f21aded9fc1620"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a958819e04ea16dfdd2f21aded9fc1620">&#9670;&nbsp;</a></span>connect() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::connect </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1AbstractOutput.html">AbstractOutput</a> &amp;&#160;</td>
          <td class="paramname"><em>output</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>alias</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Connect this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> to the provided (Abstract)<a class="el" href="classOpenSim_1_1Output.html">Output</a>. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractInput.html#a0877b842472ab90608a3c0e761878f56">OpenSim::AbstractInput</a>.</p>

<p class="reference">References <a class="el" href="classOpenSim_1_1AbstractOutput.html#ac94efb03c2b8a282bf29a7f99d66a0a5">OpenSim::AbstractOutput::getPathName()</a>, and <a class="el" href="classOpenSim_1_1AbstractOutput.html#aca6e8788f9d377d511143ce89930d238">OpenSim::AbstractOutput::getTypeName()</a>.</p>

</div>
</div>
<a id="a0a27daeceeacbee82b8aff020eeb2394"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0a27daeceeacbee82b8aff020eeb2394">&#9670;&nbsp;</a></span>disconnect()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::disconnect </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Clear references to connectees. </p>
<p>The connectee path property is not affected. Calling <a class="el" href="classOpenSim_1_1Input.html#ac624dfe7f6745cc540e24f5702c48788" title="Connect this Input given a root Component to search for the Output according to the connectee path of...">finalizeConnection()</a> will use the connectee path property to satisfy the socket. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractSocket.html#ac657088c315af6dc49b762d2acb81657">OpenSim::AbstractSocket</a>.</p>

</div>
</div>
<a id="ac624dfe7f6745cc540e24f5702c48788"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac624dfe7f6745cc540e24f5702c48788">&#9670;&nbsp;</a></span>finalizeConnection()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::finalizeConnection </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Component.html">Component</a> &amp;&#160;</td>
          <td class="paramname"><em>root</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Connect this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> given a root <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> to search for the <a class="el" href="classOpenSim_1_1Output.html">Output</a> according to the connectee path of this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> <br  />
 </p>

<p>Reimplemented from <a class="el" href="classOpenSim_1_1AbstractSocket.html#a182a30262260a0503336a0d13d4b6c8d">OpenSim::AbstractSocket</a>.</p>

<p class="reference">References <a class="el" href="classOpenSim_1_1AbstractOutput.html#a7d8a0884091b6d3ff9339ce3819f73e6">OpenSim::AbstractOutput::getChannel()</a>, <a class="el" href="classOpenSim_1_1Output.html#a6311df6bcee8cb3d03e23b07406219cb">OpenSim::Output&lt; T &gt;::getChannel()</a>, <a class="el" href="classOpenSim_1_1ComponentPath.html#a85fde6c4e026fca2d6dafc22755698db">OpenSim::ComponentPath::getNumPathLevels()</a>, <a class="el" href="classOpenSim_1_1ComponentPath.html#af3b216b7291edc20f6ee0fb06fda9788">OpenSim::ComponentPath::getSubcomponentNameAtLevel()</a>, <a class="el" href="classOpenSim_1_1ComponentPath.html#a023ec59bf5dc4ccf302b1f2d05696f5f">OpenSim::ComponentPath::isAbsolute()</a>, and <a class="el" href="classOpenSim_1_1ComponentPath.html#a465df0b4170dd05426f0f69572ca4d99">OpenSim::ComponentPath::toString()</a>.</p>

</div>
</div>
<a id="a15519bc6a26bed98722bea0161173745"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a15519bc6a26bed98722bea0161173745">&#9670;&nbsp;</a></span>getAlias() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string&amp; <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::getAlias </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the alias for a Channel. </p>
<p>An alias is a description for a Channel that is specific to how the <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> will use the Channel. For example, the <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> that owns this Input might expect the aliases to be the names of markers in the model. This method can be used only for non-list Inputs; for list Inputs, use the overload that takes an index. You must finalize connections (Component::finalizeConnections()) first. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractInput.html#a1745b26a3e3263f5cafce0d4074cb809">OpenSim::AbstractInput</a>.</p>

<p class="reference">References <a class="el" href="classOpenSim_1_1AbstractSocket.html#a0dec27d1742c1e67753e673023299b03">OpenSim::AbstractSocket::isListSocket()</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Input.html#a870abe650f0cc83ff13fedbb60122696">OpenSim::Input&lt; T &gt;::getLabel()</a>.</p>

</div>
</div>
<a id="ab3840d2041f8502ede51f07aa6ec6896"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab3840d2041f8502ede51f07aa6ec6896">&#9670;&nbsp;</a></span>getAlias() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string&amp; <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::getAlias </td>
          <td>(</td>
          <td class="paramtype">unsigned&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the alias for the Channel indicated by the provided index. </p>
<p>An alias is a description for a Channel that is specific to how the <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> will use the Channel. For example, the <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> that owns this Input might expect the aliases to be the names of markers in the model. You must finalize connections (Component::finalizeConnections()) first. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractInput.html#a667e6b607e3d3b95fa768971219efd23">OpenSim::AbstractInput</a>.</p>

<p class="reference">References <a class="el" href="classOpenSim_1_1AbstractSocket.html#a5222469e0ef65d0dad0d7d0788a6c177">OpenSim::AbstractSocket::getName()</a>, <a class="el" href="classOpenSim_1_1AbstractSocket.html#a4fc29c560fa59cbb29da0cdf4cf01ffe">OpenSim::AbstractSocket::getNumConnectees()</a>, and <a class="el" href="classOpenSim_1_1Input.html#ad27bfffd1ac259beec88da553bc48dfd">OpenSim::Input&lt; T &gt;::isConnected()</a>.</p>

</div>
</div>
<a id="adf0a9ea71a9995320a834816d68386b3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adf0a9ea71a9995320a834816d68386b3">&#9670;&nbsp;</a></span>getChannel() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOpenSim_1_1Input.html#a12f106eb91fe98191178beb550b6e1d9">Channel</a>&amp; <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::getChannel </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the Channel associated with this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>. </p>
<p>This method can only be used for non-list Input(s). For list Input(s), use the other overload. <br  />
 </p>

<p class="reference">References <a class="el" href="classOpenSim_1_1AbstractSocket.html#a0dec27d1742c1e67753e673023299b03">OpenSim::AbstractSocket::isListSocket()</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Input.html#a870abe650f0cc83ff13fedbb60122696">OpenSim::Input&lt; T &gt;::getLabel()</a>.</p>

</div>
</div>
<a id="a4c06af7101d8955413ab1133880c0318"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4c06af7101d8955413ab1133880c0318">&#9670;&nbsp;</a></span>getChannel() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOpenSim_1_1Input.html#a12f106eb91fe98191178beb550b6e1d9">Channel</a>&amp; <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::getChannel </td>
          <td>(</td>
          <td class="paramtype">unsigned&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the Channel associated with this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>. </p>
<p>Specify the index of the channel desired. <br  />
 </p>

<p class="reference">References <a class="el" href="classOpenSim_1_1AbstractSocket.html#a5222469e0ef65d0dad0d7d0788a6c177">OpenSim::AbstractSocket::getName()</a>, <a class="el" href="classOpenSim_1_1AbstractSocket.html#a4fc29c560fa59cbb29da0cdf4cf01ffe">OpenSim::AbstractSocket::getNumConnectees()</a>, and <a class="el" href="classOpenSim_1_1Input.html#ad27bfffd1ac259beec88da553bc48dfd">OpenSim::Input&lt; T &gt;::isConnected()</a>.</p>

</div>
</div>
<a id="a9b68c470e1e79597d5e1a9b79d2927d0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9b68c470e1e79597d5e1a9b79d2927d0">&#9670;&nbsp;</a></span>getChannels()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOpenSim_1_1Input.html#aaa6a4e34de1c0547076a9b2a8b4c9789">ChannelList</a>&amp; <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::getChannels </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get const access to the channels connected to this input. </p>
<p>You can use this to iterate through the channels. </p><div class="fragment"><div class="line"><span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span>&amp; chan : <a class="code" href="classOpenSim_1_1Input.html#a9b68c470e1e79597d5e1a9b79d2927d0">getChannels</a>()) {</div>
<div class="line">    std::cout &lt;&lt; chan.getValue(state) &lt;&lt; std::endl;</div>
<div class="line">}</div>
<div class="ttc" id="aclassOpenSim_1_1Input_html_a9b68c470e1e79597d5e1a9b79d2927d0"><div class="ttname"><a href="classOpenSim_1_1Input.html#a9b68c470e1e79597d5e1a9b79d2927d0">OpenSim::Input::getChannels</a></div><div class="ttdeci">const ChannelList &amp; getChannels() const</div><div class="ttdoc">Get const access to the channels connected to this input.</div><div class="ttdef"><b>Definition:</b> ComponentSocket.h:853</div></div>
</div><!-- fragment --> 
</div>
</div>
<a id="acc94ce44fe708b4b775307052428d252"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acc94ce44fe708b4b775307052428d252">&#9670;&nbsp;</a></span>getConnecteeTypeName()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::getConnecteeTypeName </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return the typename of the <a class="el" href="classOpenSim_1_1Output.html">Output</a> value, T, that satisfies this Input&lt;T&gt;. </p>
<p>No reason to return Output&lt;T&gt; since it is a given that only an <a class="el" href="classOpenSim_1_1Output.html">Output</a> can satisfy an <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractSocket.html#a8bd9bdc7613c88f6f92e9c53d3e6bd99">OpenSim::AbstractSocket</a>.</p>

</div>
</div>
<a id="aa5b6a623cc874ead09c9ff439af95627"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa5b6a623cc874ead09c9ff439af95627">&#9670;&nbsp;</a></span>getLabel() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::getLabel </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the label for this Channel. </p>
<p>If an alias has been set, the label is the alias; otherwise, the label is the full path of the <a class="el" href="classOpenSim_1_1Output.html">Output</a> that has been connected to this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>. This method can be used only for non-list Inputs; for list Inputs, use the single-argument overload. You must finalize connections (Component::finalizeConnections()) first. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractInput.html#a1e278ba638b578a915c90df79db1d767">OpenSim::AbstractInput</a>.</p>

<p class="reference">References <a class="el" href="classOpenSim_1_1AbstractSocket.html#a5222469e0ef65d0dad0d7d0788a6c177">OpenSim::AbstractSocket::getName()</a>, <a class="el" href="classOpenSim_1_1Input.html#ad27bfffd1ac259beec88da553bc48dfd">OpenSim::Input&lt; T &gt;::isConnected()</a>, and <a class="el" href="classOpenSim_1_1AbstractSocket.html#a0dec27d1742c1e67753e673023299b03">OpenSim::AbstractSocket::isListSocket()</a>.</p>

</div>
</div>
<a id="a870abe650f0cc83ff13fedbb60122696"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a870abe650f0cc83ff13fedbb60122696">&#9670;&nbsp;</a></span>getLabel() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::getLabel </td>
          <td>(</td>
          <td class="paramtype">unsigned&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the label for the Channel indicated by the provided index. </p>
<p>If an alias has been set, the label is the alias; otherwise, the label is the full path of the Channel that has been connected to this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>. You must finalize connections (Component::finalizeConnections()) first. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractInput.html#a5cafe8e84c4138b10b50e17b73e6863f">OpenSim::AbstractInput</a>.</p>

<p class="reference">References <a class="el" href="classOpenSim_1_1Input.html#a15519bc6a26bed98722bea0161173745">OpenSim::Input&lt; T &gt;::getAlias()</a>, <a class="el" href="classOpenSim_1_1Input.html#adf0a9ea71a9995320a834816d68386b3">OpenSim::Input&lt; T &gt;::getChannel()</a>, <a class="el" href="classOpenSim_1_1AbstractSocket.html#a5222469e0ef65d0dad0d7d0788a6c177">OpenSim::AbstractSocket::getName()</a>, <a class="el" href="classOpenSim_1_1AbstractSocket.html#a4fc29c560fa59cbb29da0cdf4cf01ffe">OpenSim::AbstractSocket::getNumConnectees()</a>, <a class="el" href="classOpenSim_1_1Output_1_1Channel.html#a7fc1ee7f02b1db68e72500fe40ed44a3">OpenSim::Output&lt; T &gt;::Channel::getPathName()</a>, and <a class="el" href="classOpenSim_1_1Input.html#ad27bfffd1ac259beec88da553bc48dfd">OpenSim::Input&lt; T &gt;::isConnected()</a>.</p>

</div>
</div>
<a id="a5d7ea27fe1bb3e2b065352a43232fe43"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5d7ea27fe1bb3e2b065352a43232fe43">&#9670;&nbsp;</a></span>getValue() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const T&amp; <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::getValue </td>
          <td>(</td>
          <td class="paramtype">const SimTK::State &amp;&#160;</td>
          <td class="paramname"><em>state</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the value of this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> when it is connected. </p>
<p>Redirects to connected Output&lt;T&gt;'s <a class="el" href="classOpenSim_1_1Input.html#a5d7ea27fe1bb3e2b065352a43232fe43" title="Get the value of this Input when it is connected.">getValue()</a> with minimal overhead. This method can be used only for non-list Input(s). For list Input(s), use the other overload. <br  />
 </p>

<p class="reference">References <a class="el" href="classOpenSim_1_1AbstractSocket.html#a0dec27d1742c1e67753e673023299b03">OpenSim::AbstractSocket::isListSocket()</a>.</p>

</div>
</div>
<a id="a86aa8d43b3fe1d141f4755e4797296a9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a86aa8d43b3fe1d141f4755e4797296a9">&#9670;&nbsp;</a></span>getValue() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const T&amp; <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::getValue </td>
          <td>(</td>
          <td class="paramtype">const SimTK::State &amp;&#160;</td>
          <td class="paramname"><em>state</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned&#160;</td>
          <td class="paramname"><em>index</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the value of this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> when it is connected. </p>
<p>Redirects to connected Output&lt;T&gt;'s <a class="el" href="classOpenSim_1_1Input.html#a5d7ea27fe1bb3e2b065352a43232fe43" title="Get the value of this Input when it is connected.">getValue()</a> with minimal overhead. Specify the index of the Channel whose value is desired. <br  />
 </p>

<p class="reference">References <a class="el" href="classOpenSim_1_1AbstractSocket.html#a5222469e0ef65d0dad0d7d0788a6c177">OpenSim::AbstractSocket::getName()</a>, <a class="el" href="classOpenSim_1_1AbstractSocket.html#a4fc29c560fa59cbb29da0cdf4cf01ffe">OpenSim::AbstractSocket::getNumConnectees()</a>, and <a class="el" href="classOpenSim_1_1Input.html#ad27bfffd1ac259beec88da553bc48dfd">OpenSim::Input&lt; T &gt;::isConnected()</a>.</p>

</div>
</div>
<a id="a48d5af73d4239b941e4c05a41cd3d290"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a48d5af73d4239b941e4c05a41cd3d290">&#9670;&nbsp;</a></span>getVector()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">SimTK::Vector_&lt;T&gt; <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::getVector </td>
          <td>(</td>
          <td class="paramtype">const SimTK::State &amp;&#160;</td>
          <td class="paramname"><em>state</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Access the values of all the channels connected to this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> as a SimTK::Vector_&lt;T&gt;. </p>
<p>The elements are in the same order as the channels. </p>

</div>
</div>
<a id="ad27bfffd1ac259beec88da553bc48dfd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad27bfffd1ac259beec88da553bc48dfd">&#9670;&nbsp;</a></span>isConnected()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::isConnected </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Derived classes must satisfy this Interface. </p>
<p>Is the <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> connected to its connectee(s)? For a list socket, this is only true if this socket is connected to all its connectees. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractSocket.html#a20d1a94495d9e45850004cab9b91b1f7">OpenSim::AbstractSocket</a>.</p>

<p class="reference">References <a class="el" href="classOpenSim_1_1AbstractSocket.html#a4fc29c560fa59cbb29da0cdf4cf01ffe">OpenSim::AbstractSocket::getNumConnectees()</a>.</p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Input.html#ab3840d2041f8502ede51f07aa6ec6896">OpenSim::Input&lt; T &gt;::getAlias()</a>, <a class="el" href="classOpenSim_1_1Input.html#a4c06af7101d8955413ab1133880c0318">OpenSim::Input&lt; T &gt;::getChannel()</a>, <a class="el" href="classOpenSim_1_1Input.html#aa5b6a623cc874ead09c9ff439af95627">OpenSim::Input&lt; T &gt;::getLabel()</a>, <a class="el" href="classOpenSim_1_1Input.html#a86aa8d43b3fe1d141f4755e4797296a9">OpenSim::Input&lt; T &gt;::getValue()</a>, and <a class="el" href="classOpenSim_1_1Input.html#a1cda1dcc80abf531b0217f6d3316ed80">OpenSim::Input&lt; T &gt;::setAlias()</a>.</p>

</div>
</div>
<a id="ad5b573d163af29dc4029acb12432e0a6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad5b573d163af29dc4029acb12432e0a6">&#9670;&nbsp;</a></span>safeDownCast()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOpenSim_1_1Input.html">Input</a>&lt;T&gt;* <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::safeDownCast </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1AbstractInput.html">AbstractInput</a>&lt; T &gt; *&#160;</td>
          <td class="paramname"><em>base</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>For use in python/java/MATLAB bindings. </p>

</div>
</div>
<a id="a52daca458b43b17ee594231fce365f1b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a52daca458b43b17ee594231fce365f1b">&#9670;&nbsp;</a></span>setAlias() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::setAlias </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>alias</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the alias for a Channel. </p>
<p>If this is a list <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>, the aliases of all Channels will be set to the provided string. If you wish to set the alias of only one Channel, use the two-argument overload. You must finalize connections (Component::finalizeConnections()) first. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractInput.html#a955fc6683d49f3c5fc50c3e440da4669">OpenSim::AbstractInput</a>.</p>

<p class="reference">References <a class="el" href="classOpenSim_1_1AbstractSocket.html#a4fc29c560fa59cbb29da0cdf4cf01ffe">OpenSim::AbstractSocket::getNumConnectees()</a>.</p>

</div>
</div>
<a id="a1cda1dcc80abf531b0217f6d3316ed80"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1cda1dcc80abf531b0217f6d3316ed80">&#9670;&nbsp;</a></span>setAlias() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::setAlias </td>
          <td>(</td>
          <td class="paramtype">unsigned&#160;</td>
          <td class="paramname"><em>index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>alias</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the alias for the Channel indicated by the provided index. </p>
<p>You must finalize connections (Component::finalizeConnections()) first. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractInput.html#a0f16471f64cc53a564c4cc65c4b93fc4">OpenSim::AbstractInput</a>.</p>

<p class="reference">References <a class="el" href="classOpenSim_1_1AbstractInput.html#ad11e499265b50f69bcaa3af34b972ad9">OpenSim::AbstractInput::composeConnecteePath()</a>, <a class="el" href="classOpenSim_1_1AbstractSocket.html#aaf113a0c1e31f3b28dc732928d684a06">OpenSim::AbstractSocket::getConnecteePath()</a>, <a class="el" href="classOpenSim_1_1AbstractSocket.html#a5222469e0ef65d0dad0d7d0788a6c177">OpenSim::AbstractSocket::getName()</a>, <a class="el" href="classOpenSim_1_1AbstractSocket.html#a4fc29c560fa59cbb29da0cdf4cf01ffe">OpenSim::AbstractSocket::getNumConnectees()</a>, <a class="el" href="classOpenSim_1_1Input.html#ad27bfffd1ac259beec88da553bc48dfd">OpenSim::Input&lt; T &gt;::isConnected()</a>, <a class="el" href="classOpenSim_1_1AbstractInput.html#a2062b6259d1871de344a63341f19f53d">OpenSim::AbstractInput::parseConnecteePath()</a>, and <a class="el" href="classOpenSim_1_1AbstractSocket.html#ad65c90d9c3fb2d88cc5fb698f0241a52">OpenSim::AbstractSocket::updConnecteePathProp()</a>.</p>

</div>
</div>
<a id="ad9899d15ec4d1f57db9736358819aca1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad9899d15ec4d1f57db9736358819aca1">&#9670;&nbsp;</a></span>SimTK_DOWNCAST()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1Input.html">OpenSim::Input</a>&lt; T &gt;::SimTK_DOWNCAST </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Input.html">Input</a>&lt; T &gt;&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1AbstractInput.html">AbstractInput</a>&lt; T &gt;&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>OpenSim/Common/ComponentSocket.h</li>
<li>OpenSim/Common/Component.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1Input.html">Input</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:45 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
